using System;
using System.Text;

// Microsoft using's...
using Microsoft.SPOT;

// Gadgeteer using's...
using GT = Gadgeteer;

namespace Cerberus_PWM
{
    public static class RX
    {
        // Main Program reference...
        private static Program Main;

        // Instanciate a New Timer Class...
        private static Timer timer = new Timer();


        /////////////////////////////////////////////////////////////////////////////////////////////////////
        // Our Serial Data String should look something like this :                                        //
        // <0|10000000|0.5|0>                                                                              //
        /////////////////////////////////////////////////////////////////////////////////////////////////////


        // Process RX Data Here...
        public static bool ProcessRXData(Program program, GT.SocketInterfaces.Serial sender)
        {
            // Assign Main Application Reference...
            Main = program;

            #region Get Serial Data...

            // Set a new RXD Buffer for the Incomming Data...
            byte[] RXD = new byte[sender.BytesToRead];

            // Real all the Data...
            sender.Read(RXD, 0, sender.BytesToRead);

            // Get the RXD Data and convert to String...
            string RXData = new String(Encoding.UTF8.GetChars(RXD), 0, RXD.Length);

            Debug.Print("I got serial Data: " + RXData);

            #endregion

            #region Process Serial Data Received...

            //// Seperate the Frequency and Duty Cycle into an Array...
            //string[] values = RXData.Split('|');

            //// Get the Output Timer and Channel...
            //string _Output = values[0].Substring(1, 1);

            //// Get the Frequency's ready for Parsing...
            //string _Frequency = values[1].Substring(0, 7);

            //// Get the Duty Cycle's ready for Parsing...
            //string _Duty = values[2].Substring(0, 2);

            //// Get the Mode ready for Parsing...
            //string _Mode = values[3].Substring(1, 1);

            // Set Master PWM...
            // timer.SetPWM(CPU.Output.T3Ch4, frequency, dutyCycle, true, Output.Mode.FullBridge);


            #endregion

            #region Apply Setting from Serial Data...

            //switch (RXD[0])
            //{
            //    case 49:
            //        {
            //            // int i = (int)Mode.Off;
            //            // Enum.GetName(typeof(Days), 4);
            //            // sender.Write("Mainboard says hello!!!\r\n");
            //            break;
            //        }
            //    case 50:
            //        {
            //            for (int i = 10; i != 0; i--)
            //                sender.Write("Counting..." + i + "\r\n");
            //            break;
            //        }
            //    case 51:
            //        {
            //            sender.Write("SURPRISE!!!!\r\n");
            //            break;
            //        }
            //}

            #endregion

            // Flush Buffer...
            sender.Flush();

            // Return Result...
            return true;
        }


    } // End of Class...

} // End of Namespace...
